## libobjcryst 2021.1.2+ds1

=== SConstruct ===
MY_SCONS_HELP = """\
SCons build rules for the libobjcryst C++ library
Usage: scons [target] [var=value]

Targets:

lib                 build the shared library object [default]
install             install everything under prefix directory
install-lib         install the shared library object
install-include     install the C++ header files
sdist               create source distribution tarball from git repository

Build configuration variables:
%s
Variables can be also assigned in a user-written script sconsvars.py.
SCons construction environment can be customized in sconscript.local script.
"""

import os
import platform

def subdictionary(d, keyset):
    return dict(kv for kv in d.items() if kv[0] in keyset)

# copy system environment variables related to compilation
DefaultEnvironment(ENV=subdictionary(os.environ, '''
    PATH CPATH CPLUS_INCLUDE_PATH LIBRARY_PATH LD_RUN_PATH
    LD_LIBRARY_PATH DYLD_LIBRARY_PATH DYLD_FALLBACK_LIBRARY_PATH
    MACOSX_DEPLOYMENT_TARGET
    '''.split())
)

# Create construction environment
env = DefaultEnvironment().Clone()

# Variables definitions below work only with 0.98.1 or later.
env.EnsureSConsVersion(0, 98, 1)

# Customizable compile variables
vars = Variables('sconsvars.py')

vars.Add(PathVariable(
    'prefix',
    'installation prefix directory',
    '/usr/local'))
vars.Update(env)
vars.Add(PathVariable(
    'libdir',
    'installation directory for compiled library [prefix/lib]',
    env['prefix'] + '/lib',
    PathVariable.PathAccept))
vars.Add(PathVariable(
    'includedir',
    'installation directory for C++ header files [prefix/include]',
    env['prefix'] + '/include',
    PathVariable.PathAccept))
vars.Add(EnumVariable(
    'build',
    'compiler settings',
    'fast', allowed_values=('debug', 'fast')))
vars.Add(EnumVariable(
    'tool',
    'C++ compiler toolkit to be used',
    'default', allowed_values=('default', 'intelc')))
vars.Add(BoolVariable(
    'profile',
    'build with profiling information', False))
vars.Add(BoolVariable(
    'with_shared_cctbx',
    'compile and link with the shared cctbx library', False))
vars.Update(env)
env.Help(MY_SCONS_HELP % vars.GenerateHelpText(env))

builddir = env.Dir('build/%s-%s' % (env['build'], platform.machine()))

Export('env')

if os.path.isfile('sconscript.local'):
    env.SConscript('sconscript.local')

SConscript("src/SConscript", variant_dir=builddir)

# vim: ft=python

=== debian/changelog ===
libobjcryst (2021.1.2+ds1-3) unstable; urgency=medium

  * Second fix to autopkgtest dep

 -- Neil Williams <codehelp@debian.org>  Wed, 23 Feb 2022 08:59:58 +0000

libobjcryst (2021.1.2+ds1-2) unstable; urgency=medium

  * Source-only upload
  * Fix autopkgtest deps

 -- Neil Williams <codehelp@debian.org>  Mon, 21 Feb 2022 17:21:44 +0000

libobjcryst (2021.1.2+ds1-1) unstable; urgency=medium

  * Initial release. (Closes: #1001380: ITP: libobjcryst -- Object-
    Oriented Crystallographic Library for C++)

 -- Neil Williams <codehelp@debian.org>  Tue, 21 Dec 2021 08:21:08 +0000

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Multiarch
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


%:
	dh $@

override_dh_auto_install:
	mkdir -p debian/objcryst/usr/
	LIBRARY_PATH="/usr/lib/${DEB_HOST_MULTIARCH}/" scons -Q build=debug prefix=. with_shared_cctbx=1 install
	iconv -f ISO-8859-1 -t UTF-8 debian/objcryst/usr/include/ObjCryst/ObjCryst/UnitCell.h > UnitCell.h
	mv UnitCell.h debian/objcryst/usr/include/ObjCryst/ObjCryst/UnitCell.h
	dh_installdirs
	dh_install
	dh_auto_install
	$(RM) -r debian/objcryst/usr/newmat/ debian/objcryst/usr/cctbx/cctbx/
	$(RM) -r debian/objcryst/usr/ObjCryst/ debian/objcryst/usr/SConscript*
	$(RM) -r debian/libobjcryst0/debian

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -r .sconsign.dblite debian/objcryst sconscript.local site_scons/gitarchive.cfg
	$(RM) examples/objcryst_test
	find . -name "*.pyc" -delete

=== debian/watch ===
version=4

opts="repacksuffix=+ds1,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libobjcryst-$1.tar.gz%" \
   https://github.com/diffpy/libobjcryst/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libobjcryst 2022.1.4+ds1

=== SConstruct ===
--- 
+++ 
@@ -17,10 +17,19 @@
 """
 
 import os
+from os.path import join as pjoin
 import platform
+
 
 def subdictionary(d, keyset):
     return dict(kv for kv in d.items() if kv[0] in keyset)
+
+
+def getsyspaths(*names):
+    pall = sum((os.environ.get(n, '').split(os.pathsep) for n in names), [])
+    rv = [p for p in pall if os.path.exists(p)]
+    return rv
+
 
 # copy system environment variables related to compilation
 DefaultEnvironment(ENV=subdictionary(os.environ, '''
@@ -28,7 +37,7 @@
     LD_LIBRARY_PATH DYLD_LIBRARY_PATH DYLD_FALLBACK_LIBRARY_PATH
     MACOSX_DEPLOYMENT_TARGET
     '''.split())
-)
+                   )
 
 # Create construction environment
 env = DefaultEnvironment().Clone()
@@ -39,21 +48,76 @@
 # Customizable compile variables
 vars = Variables('sconsvars.py')
 
-vars.Add(PathVariable(
-    'prefix',
-    'installation prefix directory',
-    '/usr/local'))
-vars.Update(env)
-vars.Add(PathVariable(
-    'libdir',
-    'installation directory for compiled library [prefix/lib]',
-    env['prefix'] + '/lib',
-    PathVariable.PathAccept))
-vars.Add(PathVariable(
-    'includedir',
-    'installation directory for C++ header files [prefix/include]',
-    env['prefix'] + '/include',
-    PathVariable.PathAccept))
+# Set PREFIX for installation and linking
+# TODO: also amend paths when VIRTUAL_ENV variable exists ?
+if 'PREFIX' in os.environ:
+    # building with a set prefix
+    vars.Add(PathVariable(
+        'prefix',
+        'installation prefix directory',
+        os.environ['PREFIX']))
+    vars.Update(env)
+elif 'CONDA_PREFIX' in os.environ:
+    # building for a conda environment
+    vars.Add(PathVariable(
+        'prefix',
+        'installation prefix directory',
+        os.environ['CONDA_PREFIX']))
+    vars.Update(env)
+else:
+    # Default: install in /usr/local
+    vars.Add(PathVariable(
+        'prefix',
+        'installation prefix directory',
+        '/usr/local'))
+
+if platform.system().lower() == "windows":
+    # Installation paths
+    vars.Add(PathVariable(
+        'libdir',
+        'installation directory for compiled library [prefix/Library/lib]',
+        pjoin(env['prefix'], 'Library', 'Lib'),
+        PathVariable.PathAccept))
+    vars.Add(PathVariable(
+        'includedir',
+        'installation directory for C++ header files [prefix/Library/include]',
+        pjoin(env['prefix'], 'Library', 'include'),
+        PathVariable.PathAccept))
+
+    # See https://scons.org/faq.html#Linking_on_Windows_gives_me_an_error
+    env['ENV']['TMP'] = os.environ['TMP']
+    # Prevent the generation of an import lib (.lib) in addition to the dll
+    # Unused as we are using as static library for windows
+    # env.AppendUnique(no_import_lib=1)
+
+    # Compilation and linking paths
+    env.Append(CPPPATH=[pjoin(env['prefix'], 'include')])
+    env.Append(CPPPATH=[pjoin(env['prefix'], 'Library', 'include')])
+    env.Append(LIBPATH=pjoin(env['prefix'], 'Library', 'lib'))
+else:
+    # Installation paths
+    vars.Add(PathVariable(
+        'libdir',
+        'installation directory for compiled library [prefix/lib]',
+        pjoin(env['prefix'], 'lib'),
+        PathVariable.PathAccept))
+    vars.Add(PathVariable(
+        'includedir',
+        'installation directory for C++ header files [prefix/include]',
+        pjoin(env['prefix'], 'include'),
+        PathVariable.PathAccept))
+
+    # Compilation and linking paths
+    env.Append(CPPPATH=[pjoin(env['prefix'], 'include')])
+    env.Append(LIBPATH=[pjoin(env['prefix'], 'lib')])
+
+    # Specify minimum C++ standard.  Allow later standard from sconscript.local.
+    # In case of multiple `-std` options the last option holds.
+    env.PrependUnique(CXXFLAGS='-std=c++11', delete_existing=1)
+
+# for k, v in env.Dictionary().items():
+#     print(k, v)
+
 vars.Add(EnumVariable(
     'build',
     'compiler settings',
@@ -68,8 +132,19 @@
 vars.Add(BoolVariable(
     'with_shared_cctbx',
     'compile and link with the shared cctbx library', False))
+
 vars.Update(env)
 env.Help(MY_SCONS_HELP % vars.GenerateHelpText(env))
+
+# the CPPPATH directories are checked by scons dependency scanner
+cpppath = getsyspaths('CPLUS_INCLUDE_PATH', 'CPATH')
+env.AppendUnique(CPPPATH=cpppath)
+# Insert LIBRARY_PATH explicitly because some compilers
+# ignore it in the system environment.
+env.PrependUnique(LIBPATH=getsyspaths('LIBRARY_PATH'))
+# This disable automated versioned named e.g. libboost_date_time-vc142-mt-s-x64-1_73.lib
+# so we can use conda-installed libraries
+env.AppendUnique(CPPDEFINES='BOOST_ALL_NO_LIB')
 
 builddir = env.Dir('build/%s-%s' % (env['build'], platform.machine()))

=== debian/changelog ===
libobjcryst (2022.1.4+ds1-2) unstable; urgency=medium

  * Team upload.
  * Remove the range check reversion patch.
  * Patch: Calculate constraints from symmetry before bounds-checking.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 08 Jan 2023 14:44:04 -0400

libobjcryst (2022.1.4+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Exclude bundled cctbx and newmat libraries from source tarball.
  * Refresh patches. Rework scons_debian.patch to determine the version from
    the Debian changelog.
  * Patch: Fix the example, used in the autopkgtest.
  * Patch: Revert the range check that broke our autopkgtest.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 08 Jan 2023 08:45:33 -0400

=== debian/control ===
Source: libobjcryst
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Neil Williams <codehelp@debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 scons,
 libcctbx-dev,
 libboost-dev,
 libnewmat10-dev,
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/diffpy/libobjcryst
Vcs-Browser: https://salsa.debian.org/science-team/libobjcryst
Vcs-Git: https://salsa.debian.org/science-team/libobjcryst.git
Rules-Requires-Root: no

Package: libobjcryst-dev
Section: libdevel
Architecture: amd64
Depends: libobjcryst0 (= ${binary:Version}), ${misc:Depends}
Description: Object-Oriented Crystallographic Library for C++ (headers)
 libobjcryst expands the ObjCryst++ source to make it easier
 to use as a system shared lirbary but does not include GUI related
 files from ObjCryst++.
 .
 This package contains the developer headers.

Package: libobjcryst0
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Object-Oriented Crystallographic Library for C++
 libobjcryst expands the ObjCryst++ source to make it easier
 to use as a system shared lirbary but does not include GUI related
 files from ObjCryst++.
 .
 This package contains the shared library.

=== debian/tests/control ===
Tests: example-testlib
Depends: @, g++
Restrictions: allow-stderr
Architecture: amd64
